﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using HeuristicLab.DataImporter.Data.Model;
using HeuristicLab.DataImporter.Data.CommandBase;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DataImporter.Data.Command {
  [StorableClass]
  public class RenameColumnCommand : ColumnCommandBase {
    [Storable]
    private string newName;

    private string oldName;

    private RenameColumnCommand()
      : base(null, string.Empty, -1) {
    }

    public RenameColumnCommand(DataSet dataSet, string columnGroupName, int columnIndex, string newName)
      : base(dataSet, columnGroupName, columnIndex) {
      this.newName = newName;
    }

    public override string Description {
      get { return "Rename Column"; }
    }

    public override void Execute() {
      base.Execute();
      oldName = Column.Name;
      Column.Name = newName;
      Column.FireChanged();
      this.ColumnGroup = null;
    }

    public override void UndoExecute() {
      base.UndoExecute();
      Column.Name = oldName;
      oldName = null;
      Column.FireChanged();
      this.ColumnGroup = null;
    }
  }
}
