﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using HeuristicLab.DataImporter.Data.Model;
using HeuristicLab.DataImporter.Data.CommandBase;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DataImporter.Data.Command {
  [StorableClass]
  public class RenameColumnGroupCommand : ColumnGroupCommandBase {
    [Storable]
    private string newName;

    private string oldName;

    private RenameColumnGroupCommand()
      : base(null, string.Empty) {
    }

    public RenameColumnGroupCommand(DataSet dataSet, string columnGroupName, string newName)
      : base(dataSet, columnGroupName) {
      this.newName = newName;
    }

    public override string Description {
      get { return "Rename ColumnGroup"; }
    }

    public override void Execute() {
      base.Execute();
      oldName = ColumnGroup.Name;
      ColumnGroup.Name = newName;
      ColumnGroup.FireChanged();
      this.ColumnGroup = null;
    }

    public override void UndoExecute() {
      base.UndoExecute();
      ColumnGroup ColumnGroup = this.DataSet.ColumnGroups.Where(cg => cg.Name == newName).First();
      ColumnGroup.Name = oldName;
      oldName = null;
      ColumnGroup.FireChanged();
      this.ColumnGroup = null;
    }
  }
}
